/***********************************************/
/* externs to global variables                 */
/***********************************************/
extern int done;
extern unsigned int tmax;
extern int errnum;
extern hashed_object *obdata[OBJECT_HASH_SIZE];
extern object *list;
extern object *end;
extern object *players;
extern object *playerend;
extern command *commlist[OBJECT_HASH_SIZE];
extern map *maps;
extern void set_sight ( playerstruct * pl );
/***********************************************/
/* externs to Xwindow functions                */
/***********************************************/
extern int tvecs [4][2];
extern int rit [4][2];
extern void write_text ( playerstruct *pl, char *string);
extern void write_parsing ( playerstruct *pl);
extern void clear_parsing (playerstruct *pl);
extern void refresh_text (playerstruct *pl);
extern void refresh_item (playerstruct *pl);
extern void refresh_view (playerstruct *pl);
extern void render2 (playerstruct *pl);
extern void set_pointer (playerstruct *pl);
extern void render_start (playerstruct *pl);
extern int blowup(Display *display,XErrorEvent *event);
extern void draw_controls (playerstruct *pl);
extern void refresh_commands (playerstruct *pl);
extern void refresh_stats(playerstruct *pl);

/**********************************************/
/* externs to Xwindow Startup functions       */
/**********************************************/
extern void make_player_window (playerstruct *pl);

/**********************************************/
/* externs to object functions                */
/**********************************************/
extern int xdeltas[8];
extern int ydeltas[8];
extern char align_names[NUM_ALIGN][NAMELENGTH];
extern char dir_names[8][NAMELENGTH];
extern char type_names[NUM_TYPES][15];
extern char race_names[NUM_RACES][15];
extern int obj_hash(char *name);
extern int move_object (object *obj,int dir);
extern object *readplayer (char *name);
extern object *get_general_object (char*name);
extern object *get_blank_object ();
extern void set_obj_name (object *obj, char *name);
extern map *allocate_map (int mapwidth,int maplength,char *name);
extern void add_object (object *new);
extern void insert_ob_in_map (map *amap, object *obj,int x, int y, int z);
extern void insert_ob_under_map (map *amap, object *obj,int x, int y, int z);
extern void remove_ob (object *ob);
extern void add_holding (object *holder,object *item);
extern void remove_held (object *item);
extern void free_object (object *obj);
extern void player_alloc(object *ob,playerd *copy);
extern void anim_alloc(object *ob,animd *copy);
extern void inanim_alloc(object *ob,inanimd *copy);
extern void tele_alloc(object *ob, teled *copy);
extern void armour_alloc(object *ob, armourd *copy);
extern void spell_alloc(object *ob, spelld *copy);
extern void weapon_alloc(object *ob, weapond *copy);
extern void empty_alloc(object *ob, emptyd *copy);
extern void switch_alloc(object *ob, linkerd *copy);
extern void door_alloc(object *ob, doord *copy);
extern void wall_alloc(object *ob, walld *copy);
extern void ability_alloc (object *ob,abilityd *copy);
extern void floor_alloc(object *ob, floord *copy);
extern void unlink_object(object *previous,object *current);
extern void maintain_free();
extern void set_char_statbits (char *statstr,object *ob);
extern void get_char_statbits (char *ret_string,object *ob);
extern int move_towards(object *ob,object *target);
extern object *find_nearest_player (object *ob);
extern void	add_to_hashlist(object *tmpob);
extern void remove_from_hashlist (char *name);
extern hashed_object *find_in_hash(char *name);
extern int send_to_map(object *ob,char *name,int x,int y,int z);
extern int distance(object *ob1,object *ob2);
extern void deallocate_map (map *amap);
extern int find_direction (object *ob1,object *ob2);
extern object *find_nearest_player(object *ob);
extern int damage_object (object *target,object *hitter, int damage, int type);
extern int attack_object (object *target,object *hitter,object *weapon);
extern int equip_object (object *who,object *what);
extern void free_player (playerstruct *pl);
extern void set_obj_material(char *matstr, object * obj);
extern void set_obj_resist(char *restring, object * obj);
extern void set_obj_usage(char *usestring, object * obj);
extern void set_obj_bonus(char *bonusstring,object *obj);
extern void get_obj_material(char *retstring, object * obj);
extern void get_obj_resist(char* retstring,object *obj);
extern void get_obj_usage(char* retstring,object *obj);
extern void get_obj_bonus(char* retstring,object *obj);
extern void unequip_held (object *who);
extern void pickup_object (object *who,object *what);
extern void drop_object (object *who, object *what);
extern void maintain_maps ();
extern void add_link(object *head,object *linked);
extern void turn_object(object *ob,int way);
extern void set_object_dir(object *ob,int dir);
extern object *duplicate_object (object *ob);
extern void add_channel_to_obj(object *obj,char *channel_name);
extern void set_message(object *ob,char *message);
extern int  name_hash(char *name,int size);
extern int  name_rehash(char *name,int size);
extern void send_first_channel(object *sender,int data1,void *data2);
extern void send_all_channels (object *sender,int data1,void *data2);
extern void free_all_obj_messages (object *ob);
extern void free_all_obj_channels(object *ob);

/************************************************/
/* externs to object variable control functions */
/************************************************/
extern void report_object (playerstruct *pl,object *ob);
extern void set_obj_val (playerstruct *pl,object *tmp, char *temp3,char *tempa);
 
/************************************************/
/* externs to file functions                    */
/************************************************/
extern int read_obj_data ();
extern object *readobject (FILE *datafile,int mode);
extern map *read_map_data (char *filename);
extern void write_object (object *ob, FILE *datafile);
extern int save_map_data (map *svmap,int mode);
extern void read_pic_data ();
extern char *set_up_tmpdir();

/***********************************************/
/* externs to command parsing functions        */
/***********************************************/
extern int hash_name (char *name);
extern int hash_name2 (char *name);
extern int obj_rehash (char *name);
extern void hash_commands();
extern void report_square (playerstruct *pl);
extern void inventory_report_ob (playerstruct *pl);
extern void dm_goto (playerstruct *pl);
extern void dm_place(playerstruct *pl);
extern void say (playerstruct *pl);
extern void list_obs (playerstruct *pl);
extern void quit_pl (playerstruct *pl);
extern void print_version (playerstruct *pl);
extern void get_ob (playerstruct *pl);
extern void set_game_speed (playerstruct *pl);
extern void world_report_ob (playerstruct *pl);
extern void pickup_ob (playerstruct *pl);
extern void dm_world_destroy (playerstruct *pl);
extern void save_map(playerstruct *pl);
extern void tele_map(playerstruct *pl);
extern void macro_put(playerstruct *pl);
extern void macro_destroy(playerstruct *pl);
extern void inventory_destroy (playerstruct *pl);
extern void inventory_set_val (playerstruct *pl);
extern void enter_dm_mode (playerstruct *pl);
extern void world_set_val (playerstruct *pl);

/************************************************/
/* externs to input functions                   */
/************************************************/
extern void parse_command(playerstruct * pl);
extern void decode_keypress (playerstruct *pl, XEvent event);
extern void decode_keycommand(playerstruct *pl,KeySym *key_point);
extern void handle_button (playerstruct * pl, XEvent event);
extern void get_single_key (playerstruct *pl,XEvent event);
extern void get_line (playerstruct *pl,XEvent event);
extern void get_simple_buttonpress (playerstruct * pl, XEvent event);
extern void apply_bstate(playerstruct *pl, int dir);
extern void get_no_buttonpress(playerstruct *pl,XEvent event);
extern void	reset_normal_controllers (playerstruct *pl);
extern void get_player_keys(playerstruct *pl);

/************************************************/
/* externs to handle functions                  */
/************************************************/
extern void (*handle_funcs[NUM_HANDLES][NUM_REQUESTS])();

/************************************************/
/* externs to player functions 			*/
/************************************************/
extern int move_player (playerstruct *pl,int dir);
extern object *get_selected_item (playerstruct *pl, int x, int y);
extern void shift_items_up(playerstruct * pl);
extern void shift_items_down(playerstruct * pl);
extern void shift_items_left(playerstruct * pl);
extern void shift_items_right(playerstruct * pl);

extern void cause_explosion (object * caller, map *the_map, int x_loc, int y_loc, int z_loc, int size);
