/*********************************************************/
/* file: resedit.c                                       */
/*                                                       */
/* Copyright (C) 1994 Karl A Holland                     */
/*                                                       */
/* author: Karl A Holland                                */
/*                                                       */
/* created:   1 sept 93                                  */
/*                                                       */
/* modified:  7 february 94                              */
/*                                                       */
/* contributing authors:                                 */
/*  if you add place your name here or below             */
/*                                                       */
/* description:                                          */
/*   resedit is the main object file for resedit, the    */
/* resource editor program for grudge. It will initialize*/
/* MOTIF and the neccesary data structures, and then     */
/* handle high level callbacks via its subroutines       */
/*                                                       */
/* LICENSING:                                            */
/*   a full license  is provided in the file LICENSE     */
/* which should have been included with this program when*/
/* it was copied. It may be found in the top directory   */
/* of any NORMAL distribution, named LICENSE             */
/*********************************************************/

#include <resedit.h>
#include <obcomm.h>

char allowed_type_names[NUM_ALLOWED_TYPES][16] =
{
  "Animate",
  "Inanimate",
  "Wall",
  "Floor",
  "Linker",
  "Door",
  "Teleporter",
  "Armour",
  "Spell",
  "Weapon",
  "Abilitiy"
};


int     NumNew = 1;

Widget  top,
        board,
        button_save,
        button_reload,
        button_pics,
        button_quit,
        button_edit,
        button_copy,
        button_paste,
        button_delete,
        button_new,
        button_game,
        icon_draw_area,
        draw_area_frame,
        vseparator,
        holder,
        local_buttons,
        hseparator,
        global_buttons,
        lista,
        genform,
        form_holder,
        button_holder,
        sub_form,
         name_holder,
         name_label,
         name_text,
         /*buttons_holder,*/
         type_specifics_button,
         type_menu_holder,
         type_menu,
         type_text,
         /*type_pulldown,*/
         type_choices[NUM_ALLOWED_TYPES],
         handler_holder,
handler_button,
form_frame,
button_frame,
         handler_label,
         material_button,
         resistance_button,
         link_button,
         gen_vals_holder,
         gen_vals_frame,
         vals_label_holder,
         speed_label,
         speed_text,
         physical_label,
         physical_text,
         mental_label,
         mental_text,
         wieght_label,
         wieght_text,
         bulk_label,
         bulk_text;

Display *app_display;

GC      app_GC_foreground,
        app_GC_background;

XFontStruct *itemfont;
Font        itemfontfid;
        
object *curr_item,
       *clip_board;

int     curr_num,
        curr_clip = 0; 

XtAppContext    app_context; 

void dum_fun(Widget widget, XtPointer client_data, XtPointer call_data)
{
  
}

void (*allowed_type_callbacks[NUM_ALLOWED_TYPES])() =
{
 dum_fun,
 dum_fun,
 dum_fun,
 dum_fun,
 dum_fun,
 dum_fun,
 dum_fun,
 dum_fun,
 dum_fun,
 dum_fun,
 dum_fun
};
  
static void
allcb(Widget widget, XtPointer client_data, XtPointer call_data)
{
  exit(0);
}

/*static void
allcb2(Widget widget, XtPointer client_data, XtPointer call_data)
{
  fprintf (stderr,"something selected \n");
}*/
	
static void
draw_iconCB(Widget widget, XtPointer client_data, XtPointer call_data)
{
  int    count,ylevel;
  Window draw_window = XtWindow(icon_draw_area);
  char   temp_string[2];
  object *tempobj;
 
  XClearWindow (app_display,draw_window);

  if (curr_item == NULL)
    return;
  
  temp_string[1] = '\0';

  for (count = 0; count < 4; count ++)
    {
      
      for (tempobj = curr_item,ylevel =64; tempobj != NULL;
	   tempobj = tempobj->link,ylevel-=32)
	{
	  temp_string[0] =  picnums[tempobj->picnum][count];
	  XDrawString (app_display,draw_window,app_GC_background,
		       32*(count%2),ylevel + count *50,temp_string, 1);
	  temp_string[0]++;
	  XDrawString (app_display,draw_window,app_GC_foreground,
		       32*(count%2),ylevel + count *50,temp_string, 1);
	  
	}
    }
  XFlush (app_display);
}

void
update_form()
{
  char tstring[32];
  if (curr_item != NULL)
    {
      XmTextSetString (name_text,GET_NAME(curr_item));
      sprintf (tstring,"%d",GET_PHYS(curr_item));
      XmTextSetString (physical_text,tstring);
      sprintf (tstring,"%d",GET_MENTAL(curr_item));
      XmTextSetString (mental_text,tstring);
      sprintf (tstring,"%d",GET_SPEED(curr_item));
      XmTextSetString (speed_text,tstring);
      sprintf (tstring,"%d",GET_WEIGHT(curr_item));
      XmTextSetString (wieght_text,tstring);
      sprintf (tstring,"%d",GET_BULK(curr_item));
      XmTextSetString (bulk_text,tstring);     
      SetLabel (type_text,type_names[GET_TYPE(curr_item)]);
      sprintf (tstring,"%d",curr_item->handler);
      SetLabel (handler_label,tstring);
    }
}

static void
selectcb(Widget widget, XtPointer client_data, XtPointer call_data)
{
  XmListCallbackStruct   *list_data =(XmListCallbackStruct *) call_data;
  
  curr_item = get_object_from_pos (obj_tree,list_data->item_position-1);
  curr_num = list_data->item_position ;

  update_form();

 /* fprintf(stderr,"%d = selpos \n",curr_num);*/
  
  draw_iconCB (icon_draw_area, NULL,NULL);
/*  
  if (curr_item !=NULL)
  	fprintf (stderr,"current item = %s\n",GET_NAME(curr_item));
  else
  	fprintf (stderr,"current item is NULL!\n");
*/
}

static void
editcb(Widget widget, XtPointer client_data, XtPointer call_data)
{
  
 	selectcb (widget,client_data,call_data);
 	
 	if (curr_item !=NULL)
 		fprintf (stderr,"will edit %s\n",GET_NAME(curr_item));
 	else
 		fprintf (stderr,"attempt to edit NULL item\n");
  
 }

static void
NewCB(Widget widget, XtPointer client_data, XtPointer call_data)
{
  object *new_ob;
  int   pos;
  char tname[15];

  /*XmString tstring;*/
  
  new_ob = get_blank_object (inanimate);
  
	sprintf (tname, "NewOBJ#%d",NumNew++); 

  SET_NAME (new_ob,tname);
  SET_TYPE (new_ob,inanimate);
  
  add_to_hashlist (new_ob);
  
  pos= insert_object (&obj_tree,new_ob) +1;
  
  /*fprintf(stderr,"%d = pos ,name = %s\n",pos,GET_NAME(new_ob));*/
  
  /*tstring = XmStringCreateSimple (GET_NAME(new_ob));  */
  XmListAddItem(lista,XmStringCreateSimple (GET_NAME(new_ob)),pos);
}

static void
DelCb(Widget widget, XtPointer client_data, XtPointer call_data)
{    
 	if (curr_item == NULL)
 		return;
 	
 	XmListDeletePos(lista,curr_num);
 	
 	delete_name (&obj_tree,GET_NAME(curr_item));
 	
 	remove_from_hashlist(GET_NAME(curr_item));
 	
 	free_object (curr_item);
 	
 	/*fprintf(stderr,"%d = delpos \n",curr_num);*/
 	
 	XmListSelectPos(lista,curr_num,True);
 	  
} 

static void
copycb(Widget widget, XtPointer client_data, XtPointer call_data)
{
	if (curr_item == NULL)
		return;
	
	clip_board = curr_item;
}
static void
handler_callback(Widget widget, XtPointer client_data, XtPointer call_data)
{
}
static void
type_specs_callback(Widget widget, XtPointer client_data, XtPointer call_data)
{
}
static void
material_callback(Widget widget, XtPointer client_data, XtPointer call_data)
{
}
static void
resistance_callback(Widget widget, XtPointer client_data, XtPointer call_data)
{
}
static void
link_callback(Widget widget, XtPointer client_data, XtPointer call_data)
{
}
static void
speed_callback(Widget widget, XtPointer client_data, XtPointer call_data)
{
}
static void
mental_callback(Widget widget, XtPointer client_data, XtPointer call_data)
{
  if (curr_item != NULL)
    {
      SET_MENTAL(curr_item,atoi(XmTextGetString(mental_text)));
    }
}

static void
physical_callback(Widget widget, XtPointer client_data, XtPointer call_data)
{
  if (curr_item != NULL)
    {
      SET_PHYS(curr_item,atoi(XmTextGetString(physical_text)));
    }
}

static void
name_callback(Widget widget, XtPointer client_data, XtPointer call_data)
{
  int pos;
  XmString tstring;
  if (curr_item != NULL)
    {
      XmListDeletePos(lista,curr_num);
      remove_from_hashlist(GET_NAME(curr_item));
      delete_name(&obj_tree,GET_NAME(curr_item));
      SET_NAME(curr_item,XmTextGetString(name_text));
      add_to_hashlist(curr_item);
      pos = insert_object (&obj_tree,curr_item)+1;
      tstring = XmStringCreateSimple(GET_NAME(curr_item));
      XmListAddItem(lista,tstring,pos);
      XmStringFree(tstring);
      XmListSetPos(lista,pos);
      XmListSelectPos(lista,pos,True);
    }
}

static void
pastecb(Widget widget, XtPointer client_data, XtPointer call_data)
{
	XmString tstring;
	char 		 tname[32];
 	object*  dup;
	
	if (clip_board == NULL)
		return;
	
	strcpy(tname,GET_NAME(clip_board));
	
	sprintf (tname,"%s%d",tname,++curr_clip);
	tstring = XmStringCreateSimple (tname);
	
	while (XmListItemExists(lista,tstring) && strlen (tname) < 21)
	{
		sprintf (tname,"%s!",tname);
		XmStringFree (tstring);
		tstring = XmStringCreateSimple (tname);
	}
	if (strlen (tname)<21)
	{ 
		dup = duplicate_object(clip_board);
		SET_NAME(dup,tname);
		add_to_hashlist (dup);
		XmListAddItem (lista,tstring,insert_object(&obj_tree,dup)+1);
	}
	XmStringFree(tstring);
}

void
get_font()
{
  itemfont = XLoadQueryFont(app_display,ITEMFONT);
 /* fprintf (stderr,"\n%d %s\n",(int) itemfont, ITEMFONT);*/
  itemfontfid = itemfont->fid;
}
	
void
get_GC()
{
  XGCValues temp_vals;

  temp_vals.font = itemfontfid;
  temp_vals.foreground 
    = BlackPixelOfScreen(DefaultScreenOfDisplay(app_display));
  temp_vals.background 
    = WhitePixelOfScreen(DefaultScreenOfDisplay(app_display));

  app_GC_foreground = XtGetGC (top,GCFont|GCForeground|GCBackground,
			       &temp_vals);
  temp_vals.background 
    = BlackPixelOfScreen(DefaultScreenOfDisplay(app_display));
  temp_vals.foreground 
    = WhitePixelOfScreen(DefaultScreenOfDisplay(app_display));

  app_GC_background = XtGetGC (top,GCFont|GCForeground|GCBackground,
			       &temp_vals);
}

void 
init_motif(int argc, char **argv)
{

  Arg args[20];
  int n=0;

  XtSetArg(args[n], XmNmappedWhenManaged, False);
  n++;

  XtSetArg(args[n], XmNallowResize, False);
  n++;

  XtSetArg(args[n], XmNwidth, 640);
  n++;

  XtSetArg(args[n], XmNheight, 500); 
  n++;

  top = XtAppInitialize(&app_context, "Game", (XrmOptionDescList) NULL,
         0, &argc, argv, (String *) NULL, args, n);
  
  app_display = XtDisplay(top);

  get_font();

  get_GC();
}

void
create_form_widgets()
{
 
  int    counter;
 
  form_frame = CreateFrame(board,"form_frame");
  attach_spec_position (form_frame,top_position,2);
  attach_spec_position (form_frame,left_position,48);
  attach_spec_position (form_frame,right_position,98);
  form_holder = CreateRowColV(form_frame,"form_holder");
  
  name_holder = CreateRowColH(form_holder,"name_holder");
  name_label = CreateLabel(name_holder,"name_label","Object Name:");
  name_text = CreateLineText(name_holder,"name_text",name_callback,
			     (XtPointer) NULL);

  XmTextSetMaxLength(name_text,NAMELENGTH);
  type_menu_holder = CreateRowColH(form_holder,"type_menu_holder");
  type_menu = CreatePopupMenu(type_menu_holder,"Type:");

  for (counter = 0; counter < NUM_ALLOWED_TYPES; counter ++)
    type_choices[counter] = CreatePushButton(type_menu,
					     allowed_type_names[counter],
					     (XtCallbackProc)
					     allowed_type_callbacks[counter],
					     (XtPointer) NULL);

  type_text = CreateLabel(type_menu_holder,"type_text_label","?");
  
  handler_holder = CreateRowColH (form_holder,"hold_handler");
  handler_button = CreatePushButton(handler_holder,"Handler...",
				    handler_callback,(XtPointer) NULL);
  handler_label = CreateLabel (handler_holder,"handler_label","?");

  gen_vals_frame = CreateFrame (board,"gen_vals_frame");
  attach_spec_opposite (gen_vals_frame,left_position,form_frame);
  attach_spec_opposite (gen_vals_frame,right_position,form_frame);
  attach_spec_widget (gen_vals_frame,top_position,form_frame);

  gen_vals_holder = CreateForm(gen_vals_frame,"gen_vals_holder");

  physical_label = CreateLabel (gen_vals_holder,"physical_label","Physical:");
  attach_spec_form(physical_label,top_position);
  attach_spec_form(physical_label,left_position);
  attach_spec_position(physical_label,right_position,25);

  physical_text = CreateLineText (gen_vals_holder,"physical text",
				  physical_callback,(XtPointer) NULL);

  attach_spec_widget (physical_text,left_position,physical_label);
  attach_spec_position (physical_text,right_position,50);
  attach_spec_form (physical_text,top_position);

  /*attach_spec_opposite (physical_label,bottom_position,physical_text);*/

  XmTextSetMaxLength(physical_text,10);

  mental_label = CreateLabel (gen_vals_holder,"mental_label","Mental:");
  attach_spec_widget(mental_label,left_position,physical_text);
  attach_spec_form(mental_label,top_position);
  attach_spec_position(mental_label,right_position,75);

  mental_text = CreateLineText (gen_vals_holder,"mental text",mental_callback,
			      (XtPointer) NULL);
  attach_spec_widget(mental_text,left_position,mental_label);
  attach_spec_form(mental_text,top_position);
  attach_spec_form(mental_text,right_position);

  XmTextSetMaxLength(mental_text,10);
 
  speed_label = CreateLabel (gen_vals_holder,"speed_label","Speed:");
  attach_spec_widget(speed_label,top_position,physical_text);
  attach_spec_form(speed_label,left_position);
  attach_spec_position(speed_label,right_position,25);

  speed_text = CreateLineText (gen_vals_holder,"bulk text",speed_callback,
			      (XtPointer) NULL);
  attach_spec_widget(speed_text,left_position,speed_label);
  attach_spec_opposite(speed_text,right_position,physical_text);
  attach_spec_opposite(speed_text,top_position,speed_label);

  XmTextSetMaxLength(speed_text,10);

  wieght_label = CreateLabel (gen_vals_holder,"wieght_label","Weight:");
  attach_spec_widget(wieght_label,top_position,speed_text);
  attach_spec_form(wieght_label,left_position);
  attach_spec_position(wieght_label,right_position,25);

  wieght_text = CreateLineText (gen_vals_holder,"wieght text",
				physical_callback,(XtPointer) NULL);  
  attach_spec_widget(wieght_text,left_position,wieght_label);
  attach_spec_opposite(wieght_text,top_position,wieght_label);
  attach_spec_opposite(wieght_text,right_position,speed_text);


  XmTextSetMaxLength(wieght_text,10);

  bulk_label = CreateLabel (gen_vals_holder,"bulk_label","Bulk:");
  attach_spec_opposite(bulk_label,top_position,wieght_text);
  attach_spec_widget(bulk_label,left_position,speed_text);
  attach_spec_position(bulk_label,right_position,75);
  bulk_text = CreateLineText (gen_vals_holder,"bulk text",physical_callback,
			      (XtPointer) NULL);

  attach_spec_widget(bulk_text,left_position,bulk_label);
  attach_spec_opposite(bulk_text,top_position,bulk_label);
  attach_spec_form(bulk_text,right_position);

  XmTextSetMaxLength(bulk_text,10);
 
  button_frame = CreateFrame(board,"button_frame");
  attach_spec_opposite (button_frame,left_position,gen_vals_frame);
  attach_spec_opposite (button_frame,right_position,gen_vals_frame);
  attach_spec_widget (button_frame,top_position,gen_vals_frame);

  button_holder = CreateRowColV(button_frame,"button_holder");
  
  type_specifics_button = CreatePushButton(button_holder,"Type Specifics...",
				    type_specs_callback,(XtPointer) NULL);
  material_button = CreatePushButton(button_holder,"Material...",
				     material_callback,(XtPointer) NULL);
  resistance_button = CreatePushButton(button_holder,"Resistances...",
				       resistance_callback,(XtPointer) NULL);
  link_button = CreatePushButton(button_holder,"Link....?",
				 link_callback,(XtPointer) NULL);
}
   
void
create_widgets()
{   
  board = CreateForm(top,"bbform");
  
  holder= CreateRowColV(board,"holder");
  attach_spec_position(holder,left_position,2);
  attach_spec_position(holder,top_position,2);
 
  lista = CreateList(holder, "list",
        (XtCallbackProc) selectcb, (XtCallbackProc) editcb, (XtPointer) NULL);
  
  local_buttons = CreateRowColV(board,"local");
/* local button holder position */
  attach_all_position (local_buttons,2,30,25,43);

  global_buttons = CreateRowColH(board,"global");
 /* global button holder position */
  attach_all_position (global_buttons,80,95,2,43);

  button_new = CreatePushButton(local_buttons, "New",
          (XtCallbackProc) NewCB, (XtPointer) NULL);

  button_delete = CreatePushButton(local_buttons, "Delete",
          (XtCallbackProc) DelCb, (XtPointer) NULL);
 
  button_edit = CreatePushButton(local_buttons, "Edit",
          (XtCallbackProc) allcb, (XtPointer) NULL);

  button_copy = CreatePushButton(local_buttons, "Copy",
          (XtCallbackProc) copycb, (XtPointer) NULL);

  button_paste = CreatePushButton(local_buttons,  "Paste",
          (XtCallbackProc) pastecb, (XtPointer) NULL);

  button_save = CreatePushButton(global_buttons, "Save",
          (XtCallbackProc) allcb, (XtPointer) NULL);

  button_reload = CreatePushButton(global_buttons,"Re-Load",
          (XtCallbackProc) allcb, (XtPointer) NULL);

  button_pics = CreatePushButton(global_buttons, "Pics",
          (XtCallbackProc) allcb, (XtPointer) NULL);

  button_game = CreatePushButton(global_buttons, "Game",
          (XtCallbackProc) allcb, (XtPointer) NULL);

  button_quit = CreatePushButton(global_buttons, "QUIT",
          (XtCallbackProc) allcb, (XtPointer) NULL);
           
  vseparator = CreateSeparatorV (board,"vseparator");
  /*vertical separator position */
  attach_spec_form (vseparator,top_position);
  attach_spec_form (vseparator,bottom_position);
  attach_spec_position (vseparator,right_position,46);
  attach_spec_position (vseparator,left_position,44);
  hseparator = CreateSeparatorH (board,"hseparator");
 /*horiz separator position */
  
  attach_spec_position (hseparator,top_position,77);
  attach_spec_position (hseparator,bottom_position,79);
  attach_spec_position (hseparator,right_position,45);
  attach_spec_form (hseparator,left_position);
  draw_area_frame = CreateFrame (board,"Draw_Frame");
/* the selected items icon box position */
  attach_all_position (draw_area_frame,30,75,26,42);

  icon_draw_area = CreateDrawingArea (draw_area_frame,"Selected-Icon",
				      (XtCallbackProc) draw_iconCB,
				      (XtPointer) NULL);
 
  create_form_widgets();
}


void
init_data()
{
  obj_tree = NULL;
  
  read_pic_data();
  
  if (!read_objects_in())
    fprintf(stderr, "read complete\n");
  else
  {
    fprintf(stderr, "read failed!!!\n");
    exit(2);
  }

  insert_obs_in_list(lista); 
}

int
main(int argc, char **argv)
{
  
  init_motif(argc,argv);
  create_widgets();
  init_data();
  XtRealizeWidget(top);
  XtMapWidget(top);
  XtAppMainLoop(app_context);
  return (0);
}
