/*********************************************************/
/* file: subs.c                                          */
/*                                                       */
/* Copyright (C) 1994 Karl A Holland                     */
/*                                                       */
/* author: Karl A Holland                                */
/*                                                       */
/* created:   1 april 93                                 */
/*                                                       */
/* modified:  7 february 94                              */
/*                                                       */
/* contributing authors:                                 */
/*  if you add place your name here or below             */
/*                                                       */
/* description:                                          */
/*   subs.c contains subroutines that occur frequently in*/
/* higher level object driver/handler programming        */
/*                                                       */
/* LICENSING:                                            */
/*   a full license  is provided in the file LICENSE     */
/* which should have been included with this program when*/
/* it was copied. It may be found in the top directory   */
/* of any NORMAL distribution, named LICENSE             */
/*********************************************************/
#include <standard.h>


/****************************************/
/* cause_explosion                      */
/*   use this to cause an explosion that*/
/* is centered at x,y and spreads out   */
/* size pixels in each diretion from the*/
/* center                               */
/****************************************/
void
cause_explosion (object * caller, map *the_map, int x_loc,
		 int y_loc, int z_loc, int size)
{
  int x,y;
  
  object *tobj1;

  for (x = x_loc - size; x <= x_loc + size; x ++)
    for ( y = y_loc - size; y <= y_loc + size; y ++)
      if( IN_MAP(the_map,x,y))
	{
	  if(MAP_MOVE_BLOCKED(the_map,x,y,z_loc))
	    {
	      damage_object(TOP_MAP_OBJ(the_map,x,y,z_loc),caller
			    ,(size + 1) * (size + 1), heat);
	      damage_object(TOP_MAP_OBJ(the_map,x,y,z_loc),caller
			    ,(size + 1) * (size + 1), physical);
	    }
	  
	  tobj1 = get_general_object("fire");
	  tobj1->state.normal = ((3*size)-abs(x_loc-x)-abs(y_loc-y))*2;
	  SET_PHYS(tobj1,5*(3*size)-abs(x_loc-x)-abs(y_loc-y));
	  insert_ob_in_map (the_map,tobj1,x,y,z_loc);
	  
	  tobj1 = get_general_object("expl_force");
	  tobj1->state.normal = ((3*size)-abs(x_loc-x)-abs(y_loc-y))*2;
	  SET_PHYS(tobj1,5*(3*size)-abs(x_loc-x)-abs(y_loc-y));
	  insert_ob_in_map (the_map,tobj1,x,y,z_loc);
	}
}
